'Ping_LGt3a.bas
'Es werden im folgenden Programmlisting Teile von Burkhard Kainkas
'Listing LEDmatrix1.bas verwendet, vgl. dazu auch Beitrge zur
'Programmierung der Ping-Pong-Platine 'in BASCOM AVR
'unter www.elo-web.de
'Hermann Nieder
'Oktober 2011, Februar 2012

$crystal = 8000000
$regfile = "m8def.dat"
$hwstack = 64
$swstack = 64
$framesize = 64
'nur in der Einstellungsphase dient PD1 als Ausgang(TXD)
'siehe Anmerkungen weiter unten
'$Baud = 9600


Dim Leds(12) As Word
'Dim W As Word
'Dim D As Byte
'Dim N As Word

'Dim X As Byte
'Dim Y As Byte
Dim Dat As Long
Dim Mot_dat As Byte
Dim Dat06 As Word
Dim Dat07 As Word
Dim Dat1 As Word
Dim Dat6 As Long
Dim Dat7 As Long
Dim Dat14 As Long
Dim Tausender As Word
Dim Tausender1 As Word
Dim Hunderter As Word
Dim Hunderter1 As Word
Dim Zehner As Word
Dim Zehner1 As Word
Dim Einer As Word
Dim Zeichen As Word
Dim Splt1 As Byte
Dim Splt2 As Byte
Dim Splt3 As Byte
Dim Splt4 As Byte
Dim Splt5 As Word
Dim Splt6 As Word
Dim Splt7 As Word
Dim Splt8 As Word
Dim Splt9 As Word
Dim Splt10 As Word
Dim Splt11 As Word
Dim Splt12 As Word
Dim Splt1_1 As Word
Dim Splt2_1 As Word
Dim Splt3_1 As Word
Dim K As Byte
Dim J As Byte


Config Sda = Portb.6
Config Scl = Portb.7

Declare Sub Initialisierung

'Declare Sub Led1(byval X As Byte , Byval Y As Byte)
'Declare Sub Led0(byval X As Byte , Byval Y As Byte)

Initialisierung

'Dim Xx As Single
'Dim Yy As Single

Anfang:
'nur bei vorhandener elektronische Verriegelung
'mit NOR-Gattern mglich,sonst zuerst:  Mot_dat=0!
Mot_dat = 3
Gosub I2c_write
'Anfangszustand, Motor aus
Gosub Ein1
'Eichen durch Vergleich mit AD-Wert von ADC14
'z. B. 1,23 V (vgl. Angaben in Datenblttern von 2004)
'Damit wird die Digital-Anzeige fast unabhngig von
'der Spannung Vcc
Dat14 = 0
Dat14 = Getadc(14)
'In der Einstellungsphase dient PD1 als Augang(TXD).
'Es sind zunchst die Werte fr die Fallunterscheidung
'--> Unterprogramm Auswerten zu ermitteln.
'Diese werden z. B. ber einen Pegelwandler an den PC
'gesendet und z. B. mit Terminal.exe von Burkhard Kainka
'unter Windows angezeigt. Das Programm kann unter
'www.b-Kainka.de heruntergeladen werden.
'Print "Dat14:" ; Dat14
'gosub Messen6
'gosub Messen7
'Waitms 1000
'Goto Anfang

'war Dat1=12300
Dat1 = 12500
Dat1 = Dat1 / Dat14
'Schieber in Grundposition zu Sensor vorne fahren
While Pind.1 = 0
Gosub Ein1
Mot_dat = 01
Gosub I2c_write
Wend
If Pind.1 = 1 Then
Mot_dat = 0
Gosub I2c_write
End If
'Flasche / Pfeil blinkend
Gosub Ein1

Schr1:
Gosub Ein1
'Taster oben
If Pind.3 = 1 Then
Goto Schr2
End If
If Pind.3 = 0 Then
Goto Schr1
End If

Schr2:
'Taster unten, Pfeil blinkend
Gosub Ein_pfl
If Pind.2 = 1 Then
Goto Schr3
End If
If Pind.2 = 0 Then
Goto Schr2
End If

Schr3:
Mot_dat = 02
Gosub I2c_write
'Wartezeit
Waitms 5000
Mot_dat = 0
Gosub I2c_write
'Auswerten mit optischem Sensor CNY70
Dat = 0
Dat06 = 0
Dat07 = 0
Gosub Messen6
Gosub Messen7
'
Gosub Auswerten
Waitms 4000
'Schieber zurckfahren bis Sensor hinten
Mot_dat = 02
Gosub I2c_write

Schr4:
'Schieber hinten
If Pind.0 = 1 Then
Goto Schr5
End If
If Pind.0 = 0 Then
Goto Schr4
End If

Schr5:
'Motor aus, Schieber anhalten
Mot_dat = 0
Gosub I2c_write
'Wartezeit, damit Leergut in Behlter fallen kann
Waitms 2000
While Pind.1 = 0
'Schieber wieder vorfahren bis Sensor vorne
Mot_dat = 01
Gosub I2c_write
'Anzeige Warten blinkt
Gosub Warten
Wend

If Pind.1 = 1 Then
'Schieber vorne
Mot_dat = 00
Gosub I2c_write
End If

Goto Schr1


Auswerten:
If Dat06 < 125 And Dat07 < 125 Then
Gosub Ein1
Goto Ausw_ende
End If
If Dat06 > 1000 And Dat07 < 1000 Then
Gosub Gelb
Goto Ausw_ende
End If
If Dat06 < 1000 And Dat07 > 1000 Then
Gosub Gruen
Goto Ausw_ende
End If
If Dat06 > 125 And Dat06 < 1000 And Dat07 > 125 And Dat07 < 1000 Then
Gosub Blau
Goto Ausw_ende
End If
If Dat06 > 1000 And Dat07 > 1000 Then
Gosub Rot
Goto Ausw_ende
End If
Ausw_ende:
Return


Messen6:
Dat = 0
Dat6 = 0
For J = 1 To 10
Dat = Getadc(6)
Dat6 = Dat6 + Dat
Next J
Dat = Dat6 / 10
'siehe oben
Dat = Dat * Dat1
Dat06 = Dat / 10
'nur in der Einstellungsphase PD1 als Ausgang,
'siehe Anmerkungen oben
'Print Dat06
Return

Messen7:
Dat = 0
Dat7 = 0
For J = 1 To 10
Dat = Getadc(7)
Dat7 = Dat7 + Dat
Next J
Dat = Dat7 / 10
'siehe oben
Dat = Dat * Dat1
Dat07 = Dat / 10
'nur in der Einstellungsphase PD1 als Ausgang,
'siehe Anmerkungen oben
'Print Dat07
Return


Ein1:
'Datei: Fla_Pfeil01.LED
Leds(1) = 0
Leds(2) = 504
Leds(3) = 262
Leds(4) = 262
Leds(5) = 504
Leds(6) = 0
Leds(7) = 0
Leds(8) = 32
Leds(9) = 64
Leds(10) = 640
Leds(11) = 768
Leds(12) = 896
Waitms 500
'Datei: Fla_Pfeil00.LED
Leds(1) = 0
Leds(2) = 504
Leds(3) = 262
Leds(4) = 262
Leds(5) = 504
Leds(6) = 0
Leds(7) = 0
Leds(8) = 0
Leds(9) = 0
Leds(10) = 0
Leds(11) = 0
Leds(12) = 0
Waitms 500
Return

Ein_pfl:
'Datei: Ein_Pfl1.LED
Leds(1) = 124
Leds(2) = 84
Leds(3) = 0
Leds(4) = 104
Leds(5) = 112
Leds(6) = 16
Leds(7) = 352
Leds(8) = 256
Leds(9) = 256
Leds(10) = 256
Leds(11) = 896
Leds(12) = 256
Waitms 500
 'Datei: Ein_Pfl0.LED
Leds(1) = 124
Leds(2) = 84
Leds(3) = 0
Leds(4) = 104
Leds(5) = 112
Leds(6) = 16
Leds(7) = 96
Leds(8) = 0
Leds(9) = 0
Leds(10) = 0
Leds(11) = 0
Leds(12) = 0
Waitms 500
Return

Rot:
'Datei: Rot15c.LED
Leds(1) = 1007
Leds(2) = 549
Leds(3) = 1002
Leds(4) = 512
Leds(5) = 68
Leds(6) = 1002
Leds(7) = 740
Leds(8) = 672
Leds(9) = 930
Leds(10) = 455
Leds(11) = 682
Leds(12) = 544
Return

Gelb:
'Datei: Gelb25c.LED
Leds(1) = 998
Leds(2) = 557
Leds(3) = 1005
Leds(4) = 512
Leds(5) = 934
Leds(6) = 619
Leds(7) = 738
Leds(8) = 679
Leds(9) = 936
Leds(10) = 463
Leds(11) = 682
Leds(12) = 548
Return

Gruen:
'Datei: Gruen20c.LED
Leds(1) = 998
Leds(2) = 557
Leds(3) = 1005
Leds(4) = 512
Leds(5) = 940
Leds(6) = 610
Leds(7) = 997
Leds(8) = 552
Leds(9) = 997
Leds(10) = 462
Leds(11) = 674
Leds(12) = 556
Return

Blau:
'Datei: Blau30c.LED
Leds(1) = 1023
Leds(2) = 565
Leds(3) = 1002
Leds(4) = 527
Leds(5) = 688
Leds(6) = 1000
Leds(7) = 1012
Leds(8) = 572
Leds(9) = 992
Leds(10) = 460
Leds(11) = 688
Leds(12) = 556
Return

Warten:
'Datei: Wart3_7a.LED
Leds(1) = 60
Leds(2) = 64
Leds(3) = 32
Leds(4) = 64
Leds(5) = 60
Leds(6) = 32
Leds(7) = 80
Leds(8) = 112
Leds(9) = 112
Leds(10) = 16
Leds(11) = 60
Leds(12) = 72
Waitms 500
' Anzeige aus
Leds(1) = 0
Leds(2) = 0
Leds(3) = 0
Leds(4) = 0
Leds(5) = 0
Leds(6) = 0
Leds(7) = 0
Leds(8) = 0
Leds(9) = 0
Leds(10) = 0
Leds(11) = 0
Leds(12) = 0
Waitms 500
Return



I2c_write:
I2cstart
I2cwbyte 64                                                 'z. B. des PCF8574
I2cwbyte Mot_dat                                            ' Auszugebende Daten
I2cstop
Return


'Sub Led1(byval X As Byte , Byval Y As Byte)
' If X < 13 Then
 ' Select Case Y
  '  Case 1 : Leds(x).9 = 1
  '  Case 2 : Leds(x).8 = 1
  '  Case 3 : Leds(x).7 = 1
  '  Case 4 : Leds(x).6 = 1
  '  Case 5 : Leds(x).5 = 1
  '  Case 6 : Leds(x).4 = 1
  '  Case 7 : Leds(x).3 = 1
  '  Case 8 : Leds(x).2 = 1
  '  Case 9 : Leds(x).1 = 1
  '  Case 10 : Leds(x).0 = 1
  ' End Select
  'End If
'End Sub

'Sub Led0(byval X As Byte , Byval Y As Byte)
' If X < 13 Then
'  Select Case Y
 '   Case 1 : Leds(x).9 = 0
 '   Case 2 : Leds(x).8 = 0
 '   Case 3 : Leds(x).7 = 0
 '   Case 4 : Leds(x).6 = 0
 '   Case 5 : Leds(x).5 = 0
 '   Case 6 : Leds(x).4 = 0
 '   Case 7 : Leds(x).3 = 0
 '   Case 8 : Leds(x).2 = 0
 '   Case 9 : Leds(x).1 = 0
 '   Case 10 : Leds(x).0 = 0
 '  End Select
 ' End If
'End Sub


'******************  Service-Unterprogramme *********************


Sub Initialisierung
  Config Portc = 15                                         'PORTC als AD-Eingang
  Ddrb = &B11111111
  'war in der Einstellungsphase: DDRD = &B11111010
  'siehe Anmerkungen oben
  Ddrd = &B11110000                                         'Portd.2 -> Eingang
  'Config Portd = &B1111111
  Config Timer2 = Timer , Prescale = 8
  On Ovf2 Tim2_isr
  Enable Timer2
  Enable Interrupts
  Start Timer2

 Config Adc = Single , Prescaler = 64 , Reference = Off
 Start Adc
End Sub




'******************************* Interrupt - Display ****************************

Dim Vy As Byte
Dim Col As Byte
Dim Portdout As Byte
Dim Portcout As Byte


Tim2_isr:
 '800 s
'Timer2 = 56
Col = Col + 1
If Col = 13 Then Col = 1
Vy = Col + 0
Portd = 0
Portb = 0
Portc = 0
If Col = 1 Then Portb.4 = 0 Else Portb.4 = 1
Portb.3 = 1                                                 'cl
Portb.3 = 0
Portb.2 = 1                                                 'Str
Portb.2 = 0
Portdout = Low(leds(vy))
Portcout = Portdout And 15
'Portdout = Portdout And &B11110110
Portdout = Portdout And &B11110000                          'gendert
Portd = Portdout
Portc = Portcout
Portb = High(leds(vy))
'Waitms 500
Return
End